/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#ifndef __M68MISC_INCLUDED__
#define __M68MISC_INCLUDED__

#define __inline__

#include "st0rm.h"



extern u_char           m68k_intr_run;


long LoadLFMem (void *a);
#pragma aux LoadLFMem=\
        "mov eax,[esi]"\
        "bswap eax    "\
        parm [esi] \
        value [eax];


long RorLong (u_long target);
#pragma aux RorLong=\
        "bswap eax    "\
        parm [eax] \
        value [eax];

short RorShort (u_short target);
#pragma aux RorShort=\
        "xchg al,ah   "\
        parm [ax] \
        value [ax];


void PrintRegs (void);
void PrintRegsStdio (void);
void DumpMem (void);

u_short *GivePcAddr (void);
u_short GivePcOp (void);

//u_short RorShort (u_short target);
//u_long RorLong (u_long target);

long LoadLMem (u_long pos);
short LoadWMem (u_long pos);
char LoadBMem (u_long pos);
long LoadMem (u_long pos, u_short size);

void SaveLMem (u_long pos, long to_save);
void SaveWMem (u_long pos, short to_save);
void SaveBMem (u_long pos, char to_save);
void SaveMem (u_long pos, u_short size, long to_save);

long LoadFromReg (u_long reg, u_short size);
void SaveToReg (u_long *reg, u_short size, long res);

long GiveRealType (long src, u_short size);

void Call68kIntr (u_long addr);
void M68kIntrRet (u_long addr);
void M68kExecuteN (u_long inst);


#endif
