/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#ifndef __MISC_INCLUDED__
#define __MISC_INCLUDED__

#include <i86.h>
#include "sizedefs.h"


#define KEY_ESC         1  
#define KEY_1           2
#define KEY_2           3
#define KEY_3           4
#define KEY_4           5
#define KEY_5           6
#define KEY_6           7
#define KEY_7           8
#define KEY_8           9
#define KEY_9           10
#define KEY_0           11
#define KEY_MINUS       12
#define KEY_EQUALS      13
#define KEY_BACKSPACE   14
#define KEY_TAB         15
#define KEY_Q           16
#define KEY_W           17
#define KEY_E           18
#define KEY_R           19
#define KEY_T           20
#define KEY_Y           21
#define KEY_U           22
#define KEY_I           23
#define KEY_O           24
#define KEY_P           25
#define KEY_OPENBRACE   26
#define KEY_CLOSEBRACE  27
#define KEY_ENTER       28
#define KEY_LCONTROL    29
#define KEY_A           30
#define KEY_S           31
#define KEY_D           32
#define KEY_F           33
#define KEY_G           34
#define KEY_H           35
#define KEY_J           36
#define KEY_K           37
#define KEY_L           38
#define KEY_COLON       39
#define KEY_QUOTE       40
#define KEY_TILDE       41
#define KEY_LSHIFT      42
#define KEY_Z           44
#define KEY_X           45
#define KEY_C           46
#define KEY_V           47
#define KEY_B           48
#define KEY_N           49
#define KEY_M           50
#define KEY_COMMA       51
#define KEY_STOP        52
#define KEY_SLASH       53
#define KEY_RSHIFT      54
#define KEY_ASTERISK    55
#define KEY_ALT         56
#define KEY_SPACE       57
#define KEY_CAPSLOCK    58
#define KEY_F1          59
#define KEY_F2          60
#define KEY_F3          61
#define KEY_F4          62
#define KEY_F5          63
#define KEY_F6          64
#define KEY_F7          65
#define KEY_F8          66
#define KEY_F9          67
#define KEY_F10         68
#define KEY_NUMLOCK     69
#define KEY_SCRLOCK     70
#define KEY_HOME        71
#define KEY_UP          72
#define KEY_PGUP        73
#define KEY_MINUS_PAD   74
#define KEY_LEFT        75
#define KEY_5_PAD       76
#define KEY_RIGHT       77
#define KEY_PLUS_PAD    78
#define KEY_END         79
#define KEY_DOWN        80
#define KEY_PGDN        81
#define KEY_INSERT      82
#define KEY_DEL         83
#define KEY_RCONTROL    84
#define KEY_ALTGR       85
#define KEY_F11         87
#define KEY_F12         88
#define MAX_KEY         88



extern  volatile u_long         _time_taken;


#define setvect _dos_setvect
#define getvect _dos_getvect

#define InstKbIntr() (OldKbIntr=getvect(0x09),setvect(0x09,KbIntr))
#define RemoveKbIntr() setvect(0x09,OldKbIntr)


extern volatile char keys[128];
extern volatile char ekeys[128];


extern void (interrupt far *OldKbIntr)(void);
extern void (interrupt far *OldTimeIntr)(void);
extern void interrupt far KbIntr(void);
extern void interrupt far TimeIntr(void);


void InitTimer (void);
void ReleaseTimer (void);


void ReverseString (char *buf);

void IniciaTxtVideo (void);
char *PosTxtPtr (int y, int x);

void PrintTxt (int y, int x, char *txt, ...);
void ClearTxt (void);

void PrintLog (char *txt, ...);
void PrintELog (char *txt, ...);


#endif
