/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <stdio.h>
#include <i86.h>

#include "sizedefs.h"
#include "mouse.h"

struct _mouse_          mouse;
u_long                  mouse_present;


int LockRegion (void *address, unsigned length) {

  union REGS regs;
  unsigned linear;

  linear        = (unsigned) address;

  regs.w.ax     = 0x600;
  regs.w.bx     = (linear >> 16);
  regs.w.cx     = (linear & 0xFFFF);
  regs.w.si     = (length >> 16);
  regs.w.di     = (length & 0xFFFF);

  int386 (0x31, &regs, &regs);
  return (! regs.w.cflag);
}

void _loadds far MouseHandler (int max, int mbx, int mcx, int mdx, int msi, int mdi) {
#pragma aux MouseHandler parm [EAX] [EBX] [ECX] [EDX] [ESI] [EDI]

  mouse.event           = (unsigned short) max;
  mouse.buttonstatus    = (unsigned short) mbx;
  mouse.x               = (unsigned short) mcx;
  mouse.y               = (unsigned short) mdx;
}

void cbc_end (void) {}

int MouseReset (void) {

  union REGS rin, rout;

  rin.w.ax = 0;
  int386 (0x33, &rin, &rout);

  return (rout.w.ax ? rout.w.bx : rout.w.ax);
}

void MouseSetPos (u_long x, u_long y) {

  union REGS rin;

  rin.w.cx = x;
  rin.w.dx = y;
  rin.w.ax = 4;
  int386 (0x33, &rin, &rin);
}

void MouseOn (void) {

  union REGS rin;

  rin.w.ax = 1;
  int386 (0x33, &rin, &rin);
}

void MouseOff (void) {

  union REGS rin;

  rin.w.ax = 2;
  int386 (0x33, &rin, &rin);
}

void MouseInit (void) {

  struct SREGS sregs;
  union REGS rin, rout;
  int (far *function_ptr) ();

  segread (&sregs);

  rin.w.ax = 0;
  int386 (0x33, &rin, &rout);
  if (rout.w.ax != -1) {
        mouse_present = 0; return;
  }

  mouse_present = 1;
  if ((! LockRegion (&mouse, sizeof (struct _mouse_))) ||
        (! LockRegion ((void near *) MouseHandler,
                (char *) cbc_end - (char near *) MouseHandler))) exit (1);
  rin.w.ax = 0xC;
  rin.w.cx = 0x1f;
  function_ptr = MouseHandler;
  rin.x.edx = FP_OFF (function_ptr);
  sregs.es = FP_SEG (function_ptr);
  int386x (0x33, &rin, &rout, &sregs);
  mouse.event = 0;
}
          
