

EXTRN   mem:DWORD
EXTRN   vdp:DWORD

EXTRN   v_buffer:DWORD
EXTRN   scrl_a_enable:BYTE
EXTRN   scrl_b_enable:BYTE
EXTRN   window_enable:BYTE
EXTRN   sprs_enable:BYTE
EXTRN   wait_sync:BYTE


MEMORY  STRUC
        rom_space       dd      ?
        rom_size        dd      ?
        z80_ram         db      2000h dup(?)
        io_port         db      5000h dup(?)
        ram_space       db      10000h dup(?)
        vramm           db      10000h dup(?)
        cram            db      80h dup(?)
        vsram           db      80h dup(?)
MEMORY  ENDS


VDPST   STRUC
        vert_intr       dd      ?
        horz_intr       dd      ?
        vi_enable       db      ?
        hi_enable       db      ?
        ei_enable       db      ?
        disp_enable     db      ?
        dma_enable      db      ?
        dummy           db      ?
        hv_cnt          dw      ?
        vdp_sr          dw      ?
        vdp_reg         dd      25 dup(?)
        id_code         dd      ?
        dest_addr       dd      ?
        run             dd      ?
        base_scrl_a     dd      ?
        base_scrl_b     dd      ?
        base_scrl_h     dd      ?
        base_win        dd      ?
        base_spr        dd      ?
        scrl_size_v     dd      ?
        scrl_size_h     dd      ?
        scrl_mode_v     dd      ?
        scrl_mode_h     dd      ?
        win_h_pos       dd      ?
        win_v_pos       dd      ?
        cell_mode       dd      ?
        h_cells         dd      ?
        v_cells         dd      ?
        vid_mode        dd      ?
        back_color      dd      ?
        dma_addr        dd      ?
        dma_mode        dd      ?
        dma_cnt         dd      ?
        dma_fdata       dd      ?
VDPST   ENDS
