/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#ifndef __MEMORY_INCLUDED__
#define __MEMORY_INCLUDED__


struct static_ram {

        unsigned char           z80_ram[0x2000];      // A00000 - A01FFF
        unsigned char           io_port[0x5000];      // A10000 - A11FFF A14FFF
        unsigned char           ram_space[0x10000];   // FF0000 - FFFFFF
        unsigned char           vram[0x10000];
        unsigned char           cram[0x80];
        unsigned char           vsram[0x80];
};

typedef struct {

        unsigned char          *rom_space;            //      0 - 3FFFFF
        unsigned long           rom_size;
        struct   static_ram     ram;

} Mem;




extern  Mem                     mem;
extern  char                    log_flg;
extern  FILE                   *log_file;

extern  void                   *rom_ptr;
extern  void                   *z80ram_ptr;
extern  void                   *ram_ptr;


void ExitNow (void);


#endif

