/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <mem.h>
#include "vga.h"


void Mode13 (int mode) {

  union REGS    rin, rout;

  rin.h.ah      = 0;
  rin.h.al      = (mode) ? 0x13 : 0x3;

  int386 (0x10, &rin, &rout);

  ClearMode13 ();
}

void ClearMode13 (void) {

  int                   cnt     = 16384;
  unsigned long        *p       = (unsigned long *)0xa0000;


  while (cnt--) *p++ = 0;
}

void MoveToVid (char *dest) {

  char         *vid;

  vid           = (char *) 0xa0000;

  memcpy (vid, dest, 64000);
}

void ChGfxRes (char *dest, int dest_x, int dest_y, char *src,
               int src_x, int src_y) {

  float         n_pix_y         = (float)((dest_y - src_y) / (float)src_y);
  float         n_pix_x         = (float)((dest_x - src_x) / (float)src_x);
  float         cnt_py          = 0;
  float         cnt_px          = 0;
  int           cnt_y;
  int           cnt_x;
  int           tmp_x;
  char         *dest_tmp;


  for (cnt_y = 0; cnt_y < src_y ; cnt_y++) {

        dest_tmp = dest;

        for (cnt_x = 0, tmp_x = 0; cnt_x < src_x; cnt_x++) {

                *dest++ = *src++;
                cnt_px += n_pix_x;

                if (tmp_x++ >= dest_x) break;

                if (cnt_px >= 1) {
                        cnt_px -= 1;
                        *dest++ = *src;

                        if (tmp_x++ >= dest_x) break;
                }

        }

        while (tmp_x < dest_x) {
                *dest++ = 0;
                tmp_x++;
        }

        cnt_py += n_pix_y;

        if (cnt_py >= 1) {
                cnt_py -= 1;
                for (tmp_x = 0; tmp_x < dest_x; tmp_x++)
                        *dest++ = *dest_tmp++;
        }
  }
}

void PutGfxSn (char *dest, int tot_x, int tot_y, int dest_x, int dest_y,
               char *src, int src_x, int src_y, char overlap) {

  int           dif_x   = (tot_x - src_x - dest_x);
  int           dif_y   = (tot_y - src_y - dest_y);
  int           cnt_x;
  int           cnt_y;
  int           tmp_x;


  for (cnt_y = 0; cnt_y < dest_y; cnt_y++) {
        if (!overlap)
                dest += tot_x;
        else {
                for (tmp_x = 0; tmp_x < tot_x; tmp_x++) *dest++ = 0;
        }
  }

  for (cnt_y = 0; cnt_y < src_y; cnt_y++) {
        for (cnt_x = 0; cnt_x < dest_x; cnt_x++) {
                if (!overlap)
                        dest++;
                else
                        *dest++ = 0;
        }

        for (cnt_x = 0; cnt_x < src_x; cnt_x++)
                *dest++ = *src++;

        for (cnt_x = 0; cnt_x < dif_x; cnt_x++) {
                if (!overlap)
                        dest++;
                else
                        *dest++ = 0;
        } 
  }

  for (cnt_y = 0; cnt_y < dif_y; cnt_y++) {
        if (!overlap)
                dest += tot_x;
        else {
                for (tmp_x = 0; tmp_x < tot_x; tmp_x++) *dest++ = 0;
        }
  }
}

void WaitSync (void) {

  //while ((inp(0x3da)&8)) ;
  //while (!(inp(0x3da)&8)) ;
  while ((inp(0x3da)&8)) ;
  while (!(inp(0x3da)&8)) ;
}
